#### Previous topic

scipy.signal.tukey

#### Next topic

scipy.signal.daub

# scipy.signal.cascade

`scipy.signal.``cascade`(hk, J=7)

  Return (x, phi, psi) at dyadic points `K/2**J` from filter coefficients.

  Parameters:

  hk : array_like

  > Coefficients of low-pass filter.

  J : int, optional

  > Values will be computed at grid points `K/2**J`. Default is 7.

  Returns:

  x : ndarray

  > The dyadic points `K/2**J` for `K=0...N * (2**J)-1` where `len(hk) = len(gk) = N+1`.

  phi : ndarray

  > The scaling function `phi(x)` at x: `phi(x) = sum(hk * phi(2x-k))`, where k is from 0 to N.

  psi : ndarray, optional

  > The wavelet function `psi(x)` at x: `phi(x) = sum(gk * phi(2x-k))`, where k is from 0 to N. psi is only returned if gk is not None.

  Notes

  The algorithm uses the vector cascade algorithm described by Strang and Nguyen in “Wavelets and Filter Banks”. It builds a dictionary of values and slices for quick reuse. Then inserts vectors into final vector at the end.